Subject: Re: [PATCH net-next] net: phy: bcm84881: add BCM84891/BCM84892 support

From: "Russell King (Oracle)" <[email-masked]>
Date: Tue, 24 Mar 2026 22:53:57 +0000

On Tue, Mar 24, 2026 at 09:59:02PM +0000, Daniel Wagner wrote:
> > Can you confirm whether bit 0 changes depending whether the PHY has
> > link. I don't know whether that's media link or host-side link, so
> > I suggest checking both.
> 
> Bit 12 does seem to track copper link state in my test:
>   [0s] 0x3107  bit12=1   carrier=1   plugged
>   [4s] 0x2107  bit12=0   carrier=0   unplugged
>   [19s] 0x3107  bit12=1   carrier=0   replugged, PHY sees it
>   [20s] 0x3107  bit12=1   carrier=1   phylib poll catches up
> 
> Bit 0 stayed at 1 through all of that, and through ifdown/ifup too.
> I'm not sure what it is, but it doesn't appear to track either link
> under the conditions I can test.
> 
> Bits[4:1] stayed at 3 through all of it: copper transitions, different
> copper speeds (1G, 2.5G), ifdown/ifup, on both BCM84891 and BCM84892.
> No USXGMII codes.

I suggest this is not the same register bit allocation as on
the bcm84881 in that case.

Also note that phylib's poll "catches up" because the link bit in
BMSR is intentionally sticky-down to ensure that link-down events are
not missed - if the link was down and then comes up, it intentionally
takes two reads to indicate link up to ensure that the link down state
doesn't get lost.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!